//<c>   Copyright 1987-1999 by Gerry J. Danen; all rights reserved.

//<t>   Create a dBase III Structure

#include"db_util.h"
#include"gd_extrn.h"
#include"gd_kb.h"
#include"gd_mouse.h"
#include"gd_scrn.h"
#include"gd_wn.h"


#define pgTITL_ "Create dBase III Files"


#define STR_SZ_ 133                             // string size


UCHAR   *main_menu[] =  {
        "Name",         "Enter the name of the DBF file",
        "Define",       "Define the fields for the file",
        "Create",       "Create the file",
        "Reset",        "Reset the entered information",
        "Get",          "Get field information from a space-delimited ASCII file",
        "Quit",         "Quit from this menu",
        "" };

UCHAR   *edit_option_menu[] = {
        "Add",          "Add a new entry at the end",
        "Change",       "Change the information of this entry",
        "Delete",       "Delete this entry",
        "Insert",       "Insert a new entry at the current position",
        "Next",         "Move to the NEXT entry",
        "Previous",     "Move to the PREVIOUS entry",
        "+",            "Go to next page",
        "-",            "Go to previous page",
        "Quit",         "Return to the EDIT menu",
        "" };


UCHAR   *dbffd ;                        /*  file descriptor         */
UCHAR   dbf_name[FS_LEN] = "" ;
UCHAR   sts_msg [ 81 ] ;
INT16   cur_fld, fields_defined = 0, room_left = dBC_MAX_RECLEN ;
dBFIELD layout[ dBC_MAX_FIELDS + 1 ] ;


INT16   edit_del(void);


void    reset_layout_entry( INT16 x )
{
    layout[ x ].fieldnm[0] = EOS ;
    layout[ x ].type       = 'C' ;
    layout[ x ].width      = (FLDWIDTH) 0 ;
    layout[ x ].dec        = (FLDDEC)   0 ;
}


void    reset_globals( void )
{
    INT16       i ;

    dbf_name[0] = EOS ;
    fields_defined = 0 ;
    room_left = dBC_MAX_RECLEN ;
    LOOP( i, 0, dBC_MAX_FIELDS, 1 )
    {
        reset_layout_entry( i );
    }
    sts_msg[0] = EOS ;
}


INT16   reset_tbl_entry( INT16 num )
{
    if ( ! InRange( num, 1, fields_defined ) )
        return( ERROR );
    reset_layout_entry( num );
    return( OK );
}


void    get_field_info( char *filename )
{
    FILE        *fptr ;
    UCHAR       wrk[(STR_SZ_+1)], work[(STR_SZ_+1)], *w ;
    UCHAR       lo_fieldnm[(STR_SZ_+1)], lo_type ;
    int         lo_width, lo_dec ;

    if ( (fptr = fopen( filename, "r" )) == NULL )
    {
        ErrMsg( "File %s not found", filename );
        return;
    }
    do  {
        w = fgets( work, STR_SZ_, fptr );
        if ( w )
        {
            lo_fieldnm[0] = EOS ;
            lo_type       = 'C' ;
            lo_width      =  lo_dec = 0 ;
            st_trim( work );
            strupr ( work );
            st_get_word( lo_fieldnm, work );    // get first word in string
            st_remove_word( work );             // remove word from string
            st_get_word( wrk, work );
            st_remove_word( work );
            if ( strlen(wrk) )
                lo_type = wrk[0] ;
            if ( strlen(work) )
            {
                st_get_word( wrk, work );
                st_remove_word( work );
                lo_width = atoi(wrk) ;
            }
            if ( strlen(work) )
            {
                st_get_word( wrk, work );
                st_remove_word( work );
                lo_dec = atoi(wrk) ;
            }
            if ( StrFindChar( lo_type, "CNLDM" ) == ERROR )
                lo_type = 'C' ;
            switch ( lo_type )
            {
                case 'L' :
                    lo_width = 1 ;
                    break ;
                case 'D' :
                    lo_width = 8 ;
                    break ;
                case 'M' :
                    lo_width = 10 ;
                    break ;
            }
            if ( lo_type != 'N' )
                lo_dec = 0 ;
            if ( strlen(lo_fieldnm) )
            {
                fields_defined += 1 ;
                cur_fld = fields_defined ;
                reset_tbl_entry( cur_fld );
                st_cpy( layout[cur_fld].fieldnm, lo_fieldnm, 11 );
                layout[cur_fld].type  = lo_type  ;
                layout[cur_fld].width = (FLDWIDTH) lo_width ;
                layout[cur_fld].dec   = (FLDDEC)   lo_dec   ;
            }
        }
    }   while ( ! feof( fptr ) );
    fclose( fptr );
}


void    show_status( void )
{
    INT16       i, fg ;

    if ( strlen(dbf_name) || fields_defined )
        fg = YELLOW ;
    else
        fg = vid.normal_fg ;
    room_left = dBC_MAX_RECLEN ;
    LOOP( i, 1, fields_defined, 1 )
    {
        room_left -= layout[ i ].width ;
    }
    DspMessage( 22, 1, fg, vid.normal_bg, "DBF name [%s]", dbf_name );
    DspMessage( 23, 1, fg, vid.normal_bg, "%d fields defined, %d bytes left", fields_defined, room_left );
    DspMessage( 24, 1, YELLOW, vid.normal_bg, sts_msg );
}


void    setup_show_page_line( INT16 x, INT16 curr, INT16 *fg, INT16 *bg )
{
    if ( x == curr )
    {
        *fg = vid.err_fg ;
        *bg = vid.err_bg ;
    }
    else
    {
        *fg = vid.normal_fg ;
        *bg = vid.normal_bg ;
    }
}


void    setup_show_page_blank( INT16 line )
{
    sc_scroll( 1, vid.normal_attr, line,2, line,79, SCROLL_UP );
}


void    show_tbl_page_line( INT16 x, INT16 line )
{
    UCHAR       msg[81], *typ ;
    INT16       fg, bg ;

    if ( (x < 1) || (x > fields_defined) )
        setup_show_page_blank( line );
    else
    {
        setup_show_page_line( x, cur_fld, &fg, &bg );
        switch( layout[ x ].type )
        {
            case 'C' :
                typ = "Character" ;
                break ;
            case 'N' :
                typ = "Numeric" ;
                break ;
            case 'L' :
                typ = "Logical" ;
                break ;
            case 'D' :
                typ = "Date" ;
                break ;
            case 'M' :
                typ = "Memo" ;
                break ;
            default :
                typ = "?" ;
        }
        sprintf( msg, "    %6d    %-14s%c = %-11s%5d%7d",
                 x, layout[ x ].fieldnm, layout[ x ].type, typ, layout[ x ].width, layout[ x ].dec );
        st_cat( msg, SPACE80, 79 );
        DspMessage( line,2, fg, bg, msg );
    }
}


void    show_tbl_page_line_curr( void )
{
    show_tbl_page_line( cur_fld, 14 );
    show_status();
}


/*
        Show 6 records before, and 6 records after the current record.
*/
void    show_tbl_page( void )
{
    register int i, idx, line ;

    idx  = cur_fld - 6 ;
    line = 8 ;                          /*  line to start displaying        */
    LOOP( i, 1, 13, 1 )
    {
        show_tbl_page_line( idx, line );
        idx  += 1 ;
        line += 1 ;
    }
    if ( (idx-1) < fields_defined )
        DspMessage( 21,74, vid.err_fg, vid.err_bg, " more " );
    else
        DspCh( 21,74, vid.normal_fg, vid.normal_bg, (UCHAR) '', 6 );
    show_status();
}


INT16   copy_tbl_entry( INT16 from, INT16 to )
{
    INT16       i ;

    if ( ! InRange( from, 1, fields_defined ) )
        return( ERROR );
    if ( ! InRange( to, 1, fields_defined ) )
        return( ERROR );
    if ( from == to )
        return( ERROR );
    LOOP( i, 0, 3, 1 )
    {
        st_cpy( layout[ to ].fieldnm, layout[ from ].fieldnm, 11 );
        layout[ to ].type  = layout[ from ].type  ;
        layout[ to ].width = layout[ from ].width ;
        layout[ to ].dec   = layout[ from ].dec   ;
    }
    return( OK );
}


INT16   edit_chg( void )
{
    UCHAR       *valid = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789" ;
    UCHAR       work[ 81 ], up_lim[ 5 ] ;
    INT16       x, dupl, exit_key ;

edit_f1:
    st_cpy( work, layout[cur_fld].fieldnm, 11 );
    exit_key = wn_GetLine( DISPLAY_AND_ENTER, 14, 16, WHITE, BLACK, 10, YES, work, "Valid dBase III field name" );
    if ( exit_key == ESCAPE )
        return( ESCAPE );
    /*
        Validate the name: check for duplicates, check for illegal characters.
    */
    LOOP( x, 1, ((int)(strlen(work))), 1 )
    {
        if ( work[x] == '-' || work[x] == SPACE )
            work[x] = '_' ;
    }
    if ( (work[0] < 'A') || (work[0] > 'Z') )
    {
        ErrMsg( "First character must be A-Z" );
        goto edit_f1 ;
    }
    if ( StrLegal( work, valid ) == ERROR )
    {
        ErrMsg( "Invalid character in field name. Use only \"%s\".", valid );
        goto edit_f1 ;
    }
    dupl = FALSE ;
    LOOP( x, 1, fields_defined, 1 )
    {
        if ( x != cur_fld )             /*  don't check current field   */
        {
            if ( StrEq( work, layout[ x ].fieldnm ) )
            {
                dupl = TRUE ;
                x = fields_defined ;
            }
        }
    }
    if ( dupl )
    {
        ErrMsg( "Invalid field name. \"%s\" already used.", work );
        goto edit_f1 ;
    }
    st_cpy( layout[cur_fld].fieldnm, work, 11 );
    show_tbl_page_line_curr();

edit_f2:
    show_tbl_page_line_curr();
    work[0] = layout[cur_fld].type ;
    work[1] = EOS ;
    exit_key = wn_GetLine( DISPLAY_AND_ENTER, 14, 30, WHITE, BLACK, 1, YES, work,
               "C = Character    N = Numeric    L = Logical    D = Date    M = Memo" );
    if ( exit_key == ESCAPE )
        goto edit_f1 ;
    if ( StrFindChar( work[0], "CNLDM" ) == ERROR )
    {
        ErrMsg( "Invalid data type.  Use C, N, L, D, or M, not %s.", work );
        goto edit_f2 ;
    }
    layout[cur_fld].type = work[0] ;
    if ( work[0] != 'N' )
        layout[cur_fld].dec = (FLDDEC) 0 ;
    switch ( work[0] )
    {
        case 'L' :
            layout[cur_fld].width = (FLDWIDTH) 1 ;
            return( 0 );
        case 'D' :
            layout[cur_fld].width = (FLDWIDTH) 8 ;
            return( 0 );
        case 'M' :
            layout[cur_fld].width = (FLDWIDTH) 10 ;
            return( 0 );
    }

edit_f3:
    show_tbl_page_line_curr();
    if ( layout[cur_fld].type == 'N' )
        st_cpy( up_lim, "19", 5 );
    else
        st_cpy( up_lim, "254", 5 );
    sprintf( work, "%3d", layout[cur_fld].width );
    exit_key = EnterNumber( DISPLAY_AND_ENTER, 14, 47, WHITE, BLACK, 3, 0, YES, YES, YES, NO, NO, NO, NO, work, "1", up_lim,
               "How many characters/digits in this field?" );
    if ( exit_key == ESCAPE )
        goto edit_f2 ;
    layout[cur_fld].width = (FLDWIDTH) (atoi(work)) ;
    if ( layout[cur_fld].type != 'N' )
        return( 0 );

    show_tbl_page_line_curr();
    x = layout[cur_fld].width - 2 ;
    if ( x < 1 )
    {
        layout[cur_fld].dec = 0 ;
        return( 0 );
    }
    if ( x > 15 )
        x = 15 ;
    sprintf( up_lim, "%d",  x );
    sprintf( work,   "%2d", layout[cur_fld].dec );
    exit_key = EnterNumber( DISPLAY_AND_ENTER, 14, 55, WHITE, BLACK, 2, 0, YES, YES, YES, NO, NO, NO, NO, work, "0", up_lim, "How many decimals?" );
    if ( exit_key == ESCAPE )
        goto edit_f3 ;
    layout[cur_fld].dec = (FLDDEC) (atoi(work)) ;
    return( 0 );
}


void    edit_add( void )
{
    if ( fields_defined NOT_LESS dBC_MAX_FIELDS )
    {
        ErrMsg( "Only %d fields per record allowed", dBC_MAX_FIELDS );
    }
    else
    {
        fields_defined += 1 ;
        cur_fld = fields_defined ;
        reset_tbl_entry( cur_fld );
        show_tbl_page();                        /*  update the screen       */
        if ( edit_chg() == ESCAPE )             /*  delete if aborted       */
            edit_del();
    }
}


void    edit_ins( void )
{
    INT16       i ;

    if ( fields_defined NOT_LESS dBC_MAX_FIELDS )
    {
        ErrMsg( "Only %d fields per record allowed", dBC_MAX_FIELDS );
    }
    else
    {
        fields_defined += 1 ;
        LOOPDOWN( i, fields_defined, cur_fld, 1 )
        {
            copy_tbl_entry( i, i+1 );
        }
        reset_tbl_entry( cur_fld );
        show_tbl_page();                        /*  update the screen       */
        if ( edit_chg() == ESCAPE )             /*  delete if aborted       */
            edit_del();
    }
}


INT16   edit_del( void )
{
    INT16       i ;

    if ( fields_defined < 1 )
    {
        StatusMsg( "Nothing to delete" );
        return( ERROR );
    }
    LOOP( i, cur_fld, fields_defined, 1 )
    {
        copy_tbl_entry( i+1, i );
    }
    reset_tbl_entry( fields_defined );
    fields_defined -= 1 ;
    if ( cur_fld > fields_defined )
        cur_fld = fields_defined ;
    return( OK );
}


void    edit_position( INT16 up_or_down )
{
    cur_fld += up_or_down ;
    if ( cur_fld < 1 )
        cur_fld = 1 ;
    if ( cur_fld > fields_defined )
        cur_fld = fields_defined ;
}


void    enter_DBF_name( void )
{
    FILE        *fd, *fopen();
    INT16       n ;

    DspMessage( 7, 1, vid.normal_fg, vid.normal_bg, "Enter DBF file name:" );
    wn_GetLine( DISPLAY_AND_ENTER, 7, 22, vid.normal_fg, vid.normal_bg, 58, YES, dbf_name, ".DBF is not required" );
    if ( strlen(dbf_name) )
    {
        n = StrFindChar( '.', dbf_name );
        if ( n != ERROR )                       /*  dot found, remove ext.  */
            dbf_name[n] = EOS ;
        st_cat( dbf_name, ".DBF", FS_LEN );
        if ( (fd = fopen( dbf_name, "r" )) != NULL )
        {
            ErrMsg( "File %s already exists", dbf_name );
            fclose( fd );
        }
    }
}


INT16   define_fields( void )
{
    INT16       ret, choice = 1 ;

    NewScreen();
    box( vid.normal_fg, vid.normal_bg, 5,1, 21,80, NO, 2 );
    DspMessage( 6, 6, vid.normal_fg, vid.normal_bg, "Number    Field Name    Type           Width    Dec" );
    DspCh( 7, 1, vid.normal_fg, vid.normal_bg, (UCHAR) '', 1 );
    DspCh( 7, 2, vid.normal_fg, vid.normal_bg, (UCHAR) '', 78);
    DspCh( 7,80, vid.normal_fg, vid.normal_bg, (UCHAR) '', 1 );
    if ( fields_defined )
        cur_fld = 1 ;                   /*  first entry of the table        */
    else
        cur_fld = 0 ;
    FOREVER
    {
        show_tbl_page();                /*  update the screen               */
        ret = ShowMenu( SLASH_MENU_TYPE, edit_option_menu, NO, 0, 0, &choice );
        switch( ret )
        {
            case 1 :
                edit_add();
                break;
            case 2 :
                edit_chg();
                break;
            case 3 :
                edit_del();
                break;
            case 4 :
                edit_ins();
                break;
            case 5 :
                edit_position( 1 );
                break;
            case 6 :
                edit_position( -1 );
                break;
            case 7 :
                edit_position( 13 );
                break;
            case 8 :
                edit_position( -13 );
                break;
            default:                    /*  quit                            */
                return( OK );
        }
    }
}


INT16   create_DBF( void )
{
    UCHAR       *failure = "DBF file creation failed on %s procedure" ;

    if ( ! strlen(dbf_name) )
    {
        ErrMsg( "Database must have a valid name" );
        return( ERROR );
    }
    if ( ! fields_defined )
    {
        ErrMsg( "Please define the database fields first" );
        return( ERROR );
    }
    if ( dBcreat( dbf_name, (FLDNUM) fields_defined, (&layout[1]) ) != SUCCESS )
    {
        ErrMsg( failure, "create" );
        return( ERROR );
    }
    if ( dBopen( dbf_name, &dbffd ) != SUCCESS )
    {
        ErrMsg( failure, "open" );
        return( ERROR );
    }
    dBclose( dbffd );
    dbffd = (char *) 0 ;
    sprintf( sts_msg, "Database file %s created", dbf_name );
    return( OK );
}


void    main( int argc, char *argv[] )
{
    INT16       choice, start_choice=1 ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_Break();                              // allow ^Break to abort
    ms_init();
    reset_globals();

    FOREVER
    {
        NewScreen();
        show_status();
        choice = ShowMenu( SLASH_MENU_TYPE, main_menu, NO, 0, 0, &start_choice );
        sts_msg[0] = EOS ;
        switch ( choice )
        {
            case 1 :
                enter_DBF_name();
                break ;
            case 2 :
                define_fields();
                break ;
            case 3 :
                create_DBF();
                break ;
            case 4 :
                reset_globals();
                break ;
            case 5 :
                get_field_info( argv[argc-1] );
                break ;
            case 0 :
            case 6 :
                NewScreen();
                gd_exit( 0, "" );
        }
    }
}
