//<c>   Copyright 1987-1999 by Gerry J. Danen; all rights reserved.

//<t>   Generate C Source Code from a dBase III Structure

#include"db_util.h"

#define pgTITL_ "Generate C source code from dBASE III Data Structures"


UCHAR           dbf_id  [9] ;                   /*  DBF name, uppercase */
UCHAR           dbf_id_l[9] ;                   /*  DBF name, lowercase */
UCHAR           dbf_name[FS_LEN] ;              /*  File specification  */
UCHAR           hhh_name[15] ;                  /*  Output file         */
UCHAR           work[STR_LEN] ;                 /*  work area           */
UCHAR           *dbfid ;                        /*  DBF file descriptor */
FILE            *fopen(), *outfile ;
INT16           bcount ;


void    pr_hdr_detail( INT16 num, dBFIELD *fld )
{
    UCHAR       typ[25] ;

    switch( fld->type )
    {
        case 'C' :
            if ( fld->width == 1 )
                sprintf( typ, "%s", "Character" );
            else
                sprintf( typ, "%s%d", "String .. ", fld->width );
            break ;
        case 'N' :
            sprintf( typ, "%s%d.%d", "Numeric . ", fld->width, fld->dec );
            break ;
        case 'L' :
            sprintf( typ, "%s", "Logical" );
            break ;
        case 'D' :
            sprintf( typ, "%s", "Date" );
            break ;
        case 'M' :
            sprintf( typ, "%s", "Memo" );
            break ;
        default :
            sprintf( typ, "%s", "Strange Data Type" );
    }
    if ( fld->type == 'C' && fld->width == 1 )
        fprintf( outfile, "\tUCHAR\t%-11s;\t\t\t/*  %-24s*/\n", strlwr(fld->fieldnm), typ );
    else
        fprintf( outfile, "\tUCHAR\t%-11s[%3d + 1 ] ;\t\t/*  %-24s*/\n", strlwr(fld->fieldnm), fld->width, typ );
}


INT16   pr_rd_detail( INT16 num, INT16 cnt, dBFIELD *fld )
{
    UCHAR       *yes_no ;

    if ( fld->type == 'C' )
        yes_no = "YES" ;
    else
        yes_no = "NO" ;
    if ( fld->type == 'C' && fld->width == 1 )
        fprintf( outfile, "\t\t   rec->%-11s=  bigbuf[ %3d ] ;\n", strlwr(fld->fieldnm), cnt );
    else
        fprintf( outfile, "    copy_from_dbf( rec->%-11s, &bigbuf[ %3d ] ,%3d, %-3s, YES );\n", strlwr(fld->fieldnm), cnt, fld->width, yes_no );
    return( cnt + fld->width );
}


INT16   pr_fdef_detail( INT16 num, INT16 cnt, dBFIELD *fld )
{
    UCHAR       *yes_no ;

    if ( fld->type == 'C' )
        yes_no = "YES" ;
    else
        yes_no = "NO" ;
    fprintf( outfile, "\t%3d,%4d,%3d, ", cnt, bcount, fld->width );
    if ( fld->type == 'C' && fld->width == 1 )
    {
        fprintf( outfile, "NO , NO , NO ,\n" );
    }
    else
    {
        fprintf( outfile, "%-3s, YES, YES,\n", yes_no );
        bcount += 1 ;
    }
    bcount = bcount + fld->width ;
    return( cnt + fld->width );
}


void    main( void )
{
    INT16       i, count, endfile, retcode ;
    RECLEN      reclen ;
    BYTE        month, day, year ;
    FLDNUM      nofields ;
    dBFIELD     *fields, *fldptr ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(1);

    if ( ! (fields = (dBFIELD *) malloc( (U2BYTES) sizeof(dBFIELD) * dBC_MAX_FIELDS )))
    {
        gd_exit( 1, "Not enough memory available" );
    }
    do
    {
        fprintf( stderr, "\nEnter name of dBASE III data file, no path, no .DBF > " );
        GetLine( dbf_name, FS_LEN, YES, &endfile );
        st_trim( dbf_name );
        strupr( dbf_name );
        if ( strlen(dbf_name) )
        {
            if ( (StrFindChar( '.', dbf_name )) != ERROR )  // dot!
            {
                gd_exit( 1, ".ext not allowed!" );
            }
            if ( strlen(dbf_name) > 8 )
            {
                gd_exit( 1, "Too many characters in DBF name" );
            }
            st_cpy( dbf_id  , dbf_name, 9 );
            st_cpy( dbf_id_l, dbf_name, 9 );
            st_cpy( hhh_name, dbf_name, 15);
            st_cat( hhh_name, ".HHH"  , 15);
            st_cat( dbf_name, ".DBF"  , FS_LEN );
            strlwr ( dbf_id_l );
            retcode = dBopen( dbf_name, &dbfid );
            if ( retcode == SUCCESS )
            {
                if ( (outfile = fopen(hhh_name, "w")) == NULL )
                {
                    fprintf( stderr, "Could not open output file %s\a\n", hhh_name );
                    gd_exit( 1, "" );
                }
                retcode = dBgetf( dbfid, &reclen, &month, &day, &year, &nofields, fields );
                if ( retcode == SUCCESS )
                {
                    fprintf( stderr, "\nSource for database: %s (Output to %s)", dbf_name, hhh_name );
                    fprintf( stderr, "\nRecord length      : %8d\nNumber of fields   : %8d\n", reclen, nofields );
                    fprintf( outfile, "/*\t%-12s\t\t\t%s\n\n\t<t>\tField Data Structure for %s\n\n", hhh_name, TodaysDate(), dbf_id );
                    fprintf( outfile, "\t\tRecord Length   : %d (<-- bigbuf[])\n\t\tNumber of Fields: %d\n*/\n", reclen, nofields );
                    fprintf( outfile, "#define\t%s_STR_SIZE\t%d\n", dbf_id, reclen+nofields+1 );
                    fprintf( outfile, "#define\t%s\t\tstruct %s\n%s\n{\n", dbf_id, dbf_id_l, dbf_id );
                    fprintf( outfile, "\tUCHAR\tdel_status ;\t\t\t/*  dBASE Delete Code\t    */\n" );
                    fldptr = fields ;
                    for ( i=1 ; i <= nofields ; i++, fldptr++ )
                    {
                        pr_hdr_detail( i, fldptr );
                    }
                    fprintf( outfile, "};\n/*\t--------------------\n\n" );
                    fprintf( outfile, "\tField Translation Table for %s\n*/\n", dbf_id );
                    fprintf( outfile, "DBF_FLD_REL %s_fdefs[] = {\n", dbf_id_l );
                    fldptr = fields ;
                    count  = 0 ;
                    bcount = 1 ;
                    for ( i=1 ; i <= nofields ; i++, fldptr++ )
                    {
                        count = pr_fdef_detail( i, count, fldptr );
                    }
                    fprintf( outfile, "\t-1, -1, -1, 0, 0, 0 };\n/*\t-------------------\n*/\n" );
                    fprintf( outfile, "UCHAR\t*%s_dbf = \"%s\", *%s_db ;\n", dbf_id_l, dbf_name, dbf_id_l );
                    fprintf( outfile, "%s %s ;\n", dbf_id, dbf_id_l );
                }
                else
                {
                    fprintf( stderr, "Error %d while reading header of %s\a\n", retcode, dbf_name );
                }
                fclose( outfile );
                dBclose( dbfid );
                dbfid = (char *) 0 ;
            }
            else
            {
                switch( retcode )
                {
                    case d_ERROR :
                        fprintf( stderr, "Could not open file %s\a\n", dbf_name );
                        break ;
                    case d_NODBF :
                        fprintf( stderr, "File %s is not a legal dBASE III file\a\n", dbf_name );
                        break ;
                    default :
                        fprintf( stderr, "Error %d while opening file %s\a\n", retcode, dbf_name );
                }
            }
        }
    }   while ( strlen(dbf_name) );
    free( (char *) fields );
    gd_exit( 0, "" );
}
